using System.Security.Claims;
using e_suite.API.Common;
using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;

namespace eSuite.API.UnitTests.Controllers.AuditControllerUnitTests;

public abstract class AuditControllerTestBase : TestBase
{
    protected Mock<IAuditLog> _auditLogMock = null!;
    protected AuditController _auditController = null!;

    public override async Task Setup()
    {
        await base.Setup();
        _auditLogMock = new Mock<IAuditLog>();
        _auditController = new AuditController(_auditLogMock.Object);
    }

    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(new Claim[]
        {
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        }, "TestAuthentication"));

        _auditController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}